#!/bin/bash --norc
set -f
set -o pipefail

export LC_ALL=C
export LC_ALL=C
verbose=
OPTIONS=
LONGOPTIONS=
REPOSITORY_BRANCH="sisyphus"
# alt system gits
git_default_url=git://git.altlinux.org
# alt system web shared tasks
web_default_tasks_url=http://git.altlinux.org
WEBERY_HOST=
WEB_TASKS_URL=
# alt personal gits
gitery_default_url=git://gitery.altlinux.org
gitery_default_host=
GITERY_HOST=
GIRAR_HOST=
DRY_RUN=
verbose=1
missing_mode=
no_output_mode=

for config_file in /etc/girar-nmu/default ${XDG_CONFIG_HOME:-$HOME/.config}/girar-nmu/default; do
    ! [ -e "$config_file" ] || . "$config_file"
done
# --- autodetection in absence of config file ---
if [ -z "$gitery_default_host" ]; then
    if grep -E '^Host[[:space:]]+gitery[[:space:]]*$' ~/.ssh/config >/dev/null; then
	gitery_default_host=gitery
    elif grep -E '^Host[[:space:]]+git.alt[[:space:]]*$' ~/.ssh/config >/dev/null; then
	gitery_default_host=git.alt
    else
	gitery_default_host=gitery
    fi
fi
if [ -z "$GIRAR_HOST" ]; then
    if grep -E '^Host[[:space:]]+girar[[:space:]]*$' ~/.ssh/config >/dev/null; then
	GIRAR_HOST=girar
    elif grep -E '^Host[[:space:]]+gyle[[:space:]]*$' ~/.ssh/config >/dev/null; then
	GIRAR_HOST=gyle
    elif grep -E '^Host[[:space:]]+gyle.alt[[:space:]]*$' ~/.ssh/config >/dev/null; then
	GIRAR_HOST=gyle.alt
    elif grep -E '^Host[[:space:]]+sborochnitsa[[:space:]]*$' ~/.ssh/config >/dev/null; then
	GIRAR_HOST=sborochnitsa
    else
	GIRAR_HOST=girar
    fi
fi
# --- end autodetection ---------------------------

OPTIONS=m,Q
LONGOPTIONS=,missing,show-missing,no-output
# not compatible with set -e
#getopt --test > /dev/null; #if [ "$?" -ne 4 ]; then
if getopt --test > /dev/null; then
    echo "Oops! `getopt --test` not failed. Bad getopt!." >&2
    exit 1
fi
__OPTS=hqVvb:H:P:R:
__LONGOPTS=dry-run,help,quiet,verbose,version,branch:,girar:,gyle:,gitery:,git.alt:,profile:,webery:,web_tasks_url:
PARSED=$(getopt --options=$__OPTS$OPTIONS --longoptions=$__LONGOPTS$LONGOPTIONS --name "$0" -- "$@")
if [ "$?" -ne 0 ]; then
    exit 2
fi
eval set -- "$PARSED"
while true; do
    case "$1" in
	-m|--missing|--show-missing)
	    missing_mode=1
            shift 1 ;;
	-Q|--no-output)
	    no_output_mode=1
	    verbose=
            shift 1 ;;
	-P|--profile)
	    local profile_file="$2"
	    for config_file in /etc/girar-nmu/"$profile_file" ${XDG_CONFIG_HOME:-$HOME/.config}/girar-nmu/"$profile_file"; do
		! [ -e "$config_file" ] || . "$config_file"
	    done
            shift 2 ;;
        -q|--quiet)
            verbose=
            shift ;;
        -V|--version)
            echo "2.015.2"
	    exit 0
            shift ;;
        -v|--verbose)
            verbose=$(($verbose+1))
            shift ;;
	-h|--help)
	    pod2usage --exit=0 "$0";
	    exit 0 ;;
	-b|--branch)
	    REPOSITORY_BRANCH="$2"
	    readonly REPOSITORY_BRANCH
            shift 2 ;;
	-H|--gitery|--git.alt)
	    GITERY_HOST="$2"
	    readonly GITERY_HOST
            shift 2 ;;
	-R|--girar|--gyle)
	    GIRAR_HOST="$2"
	    readonly GIRAR_HOST
            shift 2 ;;
	-W|--webery)
	    WEBERY_HOST="$2"
	    readonly WEBERY_HOST
            shift 2 ;;
	--web-tasks-url)
	    WEB_TASKS_URL="$2"
	    readonly WEB_TASKS_URL
            shift 2 ;;
        --dry-run)
            DRY_RUN=echo
            shift ;;
        --)
            shift
            break
            ;;
        *)
	    echo "Internal error: Unexpected option: $1 $2" >&2
	    #pod2usage --exit=3 "$0"
            exit 3
            ;;
    esac
done

name="$1"
if [ -z "$name" ]; then
    echo "The first argument - name - is mandatory." >&2
    pod2usage --exit=2 "$0"; exit 2;
fi

#4_set_verbose_option

commit=`git ls-remote -h ${GITERY_HOST:-$git_default_url}:/gears/${name:0:1}/${name}.git refs/heads/$REPOSITORY_BRANCH 2>/dev/null`
GITRETVAL=$?
if [ $GITRETVAL -eq 0 ] && [ -n "$commit" ]; then
    [ -n "$no_output_mode" ] || echo git
    exit 0;
fi
commit=`git ls-remote -h ${GITERY_HOST:-$git_default_url}:/srpms/${name:0:1}/${name}.git refs/heads/$REPOSITORY_BRANCH 2>/dev/null`
SRPMRETVAL=$?
if [ $SRPMRETVAL -eq 0 ] && [ -n "$commit" ]; then
    [ -n "$no_output_mode" ] || echo srpm
    exit 3;
fi
missing_exit_code=4
if [ $GITRETVAL -eq 0 ] && [ $SRPMRETVAL -eq 0 ]; then
    [ -n "$verbose" ] && [ $verbose -ge 2 ] && echo "info: $name is present in both git and srpm build history." >&2
    missing_exit_code=7
elif [ $GITRETVAL -ne 0 ] && [ $SRPMRETVAL -eq 0 ]; then
    [ -n "$verbose" ] && [ $verbose -ge 2 ] && echo "info: $name is present in srpm build history." >&2
    missing_exit_code=5
elif [ $GITRETVAL -eq 0 ] && [ $SRPMRETVAL -ne 0 ]; then
    [ -n "$verbose" ] && [ $verbose -ge 2 ] && echo "info: $name is present in git build history." >&2
    missing_exit_code=6
elif [ $GITRETVAL -ne 0 ] && [ $SRPMRETVAL -ne 0 ]; then
    if [ -n "$verbose" ] && [ $verbose -ge 1 ] && ([ $verbose -ge 2 ] || [ -z "$missing_mode" ]); then
	echo "warning: $name not found at ${GITERY_HOST:-$git_default_url}." >&2
    fi
    missing_exit_code=4
fi
if [ -n "$missing_mode" ]; then
    [ -n "$no_output_mode" ] || echo missing
    missing_exit_code=4
else
    [ -n "$no_output_mode" ] || echo srpm
fi
exit $missing_exit_code;

: <<'__EOF__'

=head1	NAME

girar-get-upload-method - get girar upload method (srpm or gear) for a package.

=head1	SYNOPSIS

B<girar-get-upload-method>
[B<-m|--missing>]
[B<-H|--gitery> I<ssh gitery alias>]
[B<-R|--girar> I<ssh girar(gule) alias>]
[B<-W|--webery> I<tasks web site>]
[B<--web-tasks-url> I<tasks web site url>]
[B<-b|--branch> I<repository>]
[B<--dry-run>]
[B<-P|--profile> I<profile>]
[B<-h|--help>]
[B<-v|--verbose>]
[B<-q|--quiet>]

I<name>

=head1	DESCRIPTION

B<girar-get-upload-method> I<name> returns: 
* string 'gear' and exit code 0 if package was uploaded as gear repository;
* string 'srpm' and exit code 3 if package was uploaded as srpm package.

if package name can not be found in the repository,
in default mode it returns string 'srpm' and exit codes 4-7
(4 - name not found in history, 5 - name found in git history,
6 - name found in srpm history, 7 - name found in both git and srpm history)
Also,  a warning is printed to stderr.
 
With B<--missing> option if package name can not be found in the repository
it returns string 'missing' and exit code 4.

Note that for simple checks exit code is 0 if package was uploaded as gear repository
and not 0 otherwise.

=head1	OPTIONS

=over

=item	B<-m|--missing|--show-missing>

`Missing' mode. if package name can not be found in the repository,
in default mode it returns string 'srpm'. In
`Missing' mode it returns string 'missing'.

=item	B<-Q|--no-output>

`No output' mode. Only exit code is returned.

=item	B<-b|--branch> I<repository branch>

Name of the repository branch. Values: sisyphus|p8|..
Default is sisyphus.

=item	B<-R|--girar> I<girar(gyle) ssh alias>

By default, gyle.altlinux.org account should be configured as girar or gyle in ~/.ssh/config.
If you do not follow that convention, use -R <your girar ssh alias> option.

=item	B<-H|--gitery> I<gitery ssh alias>

Alternative gitery or ssh alias for gitery, for example, git.e2k.
If not specified, by default, gitery is used where ssh account is
required and git.altlinux.org is used where http:// is enough.

=item	B<-W|--webery> I<tasks web site>

Alternative site that hosts girar tasks.
If not specified, by default, git.altlinux.org is used.

=item	[B<--web-tasks-url> I<tasks web site url>]

The default URL for web task site is http://I<tasks web site>.
See --webery for details. B<--web-tasks-url> overrides this URL.

=item	B<--dry-run>

Echo state-changing commands instead of doing them. An extra safety.
Also a bit useful for debugging.

=item	B<-P|--profile> I<profile>

Name of the configuration profile. The profile is loaded as
/etc/girar-nmu/I<profile> and $HOME/.config/girar-nmu/I<profile>.
Note that default configuration is stored in
/etc/girar-nmu/default and $HOME/.config/girar-nmu/default.

=item	B<-V|--version>

Print version and exit.

=item	B<-v|--verbose>

Verbose. Prints extra information. Multiple -v accumulate.
-v -v -v set debug mode (set -x).

=item	B<-q|--quiet>

Quiet. Print no warnings.

=item	B<-h|--help>

Display this help and exit.


=back

=head1	AUTHOR

Written by Igor Vlasenko <viy@altlinux.org>.

=head1	COPYING

Copyright (c) 2010-2022 Igor Vlasenko, ALT Linux Team.

This is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

=cut

__EOF__
